﻿local m = Minimap
local font = "FONTS\\FRIZQT__.ttf"
local wMmap = CreateFrame("Frame")

local minimapshape = "square" -- square or round shape of minimap
showDate = true -- Set to false to hide date

m:ClearAllPoints()
m:SetPoint("TOPRIGHT", UIParent, -15, -15)
m:SetScale(1) -- Change to make the Scale of the minimap big or small 0.10 to 0.01 "small" = 1 to 10 big

if minimapshape == "round" then 
function GetMinimapShape() return "ROUND" end
	m:SetMaskTexture("Interface\\AddOns\\wMmap\\texture\\Mask-ROUND")
	
        local r = m:CreateTexture(nil,"round")
	r:SetTexture("Interface\\AddOns\\wMmap\\texture\\round")
	r:SetPoint("TOPLEFT", m, "TOPLEFT", -12, 12)
	r:SetPoint("BOTTOMRIGHT", m, "BOTTOMRIGHT", 12, -12)
	r:SetBlendMode("BLEND")

elseif minimapshape == "square" then 
function GetMinimapShape() return "SQUARE" end
	m:SetMaskTexture("Interface\\AddOns\\wMmap\\texture\\Mask.blp")
	
        local s = m:CreateTexture(nil,"square")
	s:SetTexture("Interface\\AddOns\\wMmap\\texture\\square")
	s:SetPoint("TOPLEFT", m, "TOPLEFT", -12, 12)
	s:SetPoint("BOTTOMRIGHT", m, "BOTTOMRIGHT", 12, -12)
	s:SetBlendMode("BLEND")
	end

-- Hide stuff
	MiniMapWorldMapButton:Hide()
	MinimapBorderTop:Hide()
	MinimapNorthTag:Hide()
	MinimapZoomOut:Hide()
	MinimapZoomIn:Hide()
        MiniMapTracking:Hide()
	MinimapBorder:Hide()
        GameTimeFrame:Hide()

-- SLASH COMMANDS
SlashCmdList["wMmap"] = function()
	DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Use Left Mouse Button to ping the minimap")
	DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Use Middle Mouse Button to open calander")
	DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Use Right Mouse Button to show tracking dropdown menu")
	DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Use Alt+Left Mouse Button to move minimap")
	DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Type |cffFF0000/wmreset|r to set minimap to default position")
        DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Type |cffFF0000/wf|r Use Left Mouse Button to move Quest Frame, and to lock and unlock")
	DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Type |cffFF0000/rl|r to reload the ui")
end
SlashCmdList["wMmapRETURN"] = function()
	m:SetPoint("TOPRIGHT", UIParent, -15, -15)
	DEFAULT_CHAT_FRAME:AddMessage("|cff3399FFwMmap|r: Returned to default position")
end
SlashCmdList["RELOADUI"] = function() ReloadUI() end
SLASH_wMmap1 = "/wm"
SLASH_wMmapRETURN1 = "/wmreset"
SLASH_RELOADUI1 = "/rl"

-- QUESTTRACKER
local wf = WatchFrame
local wfmove = false 

wf:SetMovable(true);
wf:SetClampedToScreen(false); 
wf:ClearAllPoints()
wf:SetPoint("TOPRIGHT", m, "BOTTOMRIGHT", 0, -80)
wf:SetUserPlaced(true)
wf.SetPoint = function() end
wf:SetScale(0.8)

local function WATCHFRAMELOCK()
	if wfmove == false then
		wfmove = true
		print("|cff00ff00Quest Watch Frame unlocked for drag|cFF00FFFF")
		wf:EnableMouse(true);
		wf:RegisterForDrag("LeftButton"); 
		wf:SetScript("OnDragStart", wf.StartMoving); 
		wf:SetScript("OnDragStop", wf.StopMovingOrSizing);
	elseif wfmove == true then
		wf:EnableMouse(false);
		wfmove = false
		print("|cff00ff00Quest Watch Frame locked|cFF00FFFF")
	end
end

SLASH_WATCHFRAMELOCK1 = "/wf"
SlashCmdList["WATCHFRAMELOCK"] = WATCHFRAMELOCK

-- Zone text
MinimapZoneTextButton:SetPoint("TOP", m, "TOP", 0, 4)
MinimapZoneTextButton:SetFrameLevel(5)
MinimapZoneText:SetFont(font, 10, "OUTLINE")

-- BATTLEGROUND ICON TOP
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("TOP", m, 0, -3)
MiniMapBattlefieldFrame:SetScale(.9)
MiniMapBattlefieldBorder:Hide()

-- Minimap Instance Difficulty TOP RIGHT
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", m, 0, -4)
MiniMapInstanceDifficulty:SetFrameStrata("HIGH")

-- LFG FRAME BOTTOM RIGHT
function UpdateLFG()
MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrame:SetParent(m)
MiniMapLFGFrame:SetPoint("BOTTOMRIGHT", m, 0, -3)
MiniMapLFGFrame:SetScale(.9)
    LFDSearchStatus:ClearAllPoints()
    LFDSearchStatus:SetPoint("TOPRIGHT", MiniMapLFGFrame, "TOPRIGHT")
end
MiniMapLFGFrameBorder:SetAlpha(0)
DropDownList1:SetClampedToScreen(true)
hooksecurefunc("MiniMapLFG_UpdateIsShown", UpdateLFG)

-- MAIL FRAME BOTTOM
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetParent(m)
MiniMapMailFrame:SetPoint('BOTTOM', 0, 18)
MiniMapMailFrame:SetHeight(10)
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture("Interface\\AddOns\\wMmap\\texture\\mail")

-- Time
LoadAddOn('Blizzard_TimeManager')
local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
clockFrame:Hide()
clockTime:Show()
clockTime:SetFont(font, 14)
    if(CalendarGetNumPendingInvites() > 0) then
		clockTime:SetTextColor(0, 1, 0) -- Red
	else
		clockTime:SetTextColor(1, 1, 1) -- White
    end
TimeManagerClockButton:SetPoint("CENTER", m, "BOTTOM", -2, 2)

if showDate then
	local fdate = CreateFrame("Frame", nil, UIParent)

	fdate.text = fdate:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
	fdate.text:SetPoint("TOP", m, "BOTTOM", -3, -4)

	fdate:SetScript("OnUpdate", function()
		fdate.text:SetText(date("%a %d/%b"))
	end)
end

-- Zoom
m:SetZoom(0)
m:EnableMouseWheel(true)
	m:SetScript("OnMouseWheel", function()
		if arg1 > 0 then Minimap_ZoomIn() else Minimap_ZoomOut() end
	end)

-- Set Clicks
m:SetScript('OnMouseUp', function(self, button)
    if (button == 'RightButton') then
        ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, - (m:GetWidth() * 0.7), -3)
    elseif (button == 'MiddleButton') then
        ToggleCalendar()
    else
        Minimap_OnClick(self)
    end
end)

-- Move Stuff
  	m:RegisterForDrag("LeftButton")
	m:SetClampedToScreen(true)
	m:SetMovable(true)
	m:SetScript("OnDragStart", function(self) if IsAltKeyDown() and IsControlKeyDown() then self:StartMoving() end end)
	m:SetScript("OnDragStop", function(self) if IsAltKeyDown() and IsControlKeyDown() then self:StopMovingOrSizing() end end)

m:SetFrameStrata("BACKGROUND")
wMmap:SetScript("OnEvent", event)
wMmap:RegisterEvent("PLAYER_LOGIN") 
DEFAULT_CHAT_FRAME:AddMessage("|cff3399FF w|rMmap: |cff3399FF4.0|r Loaded - |cff3399FF/wm|r for more information")